routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

// Admin routes
Route::name('admin.')->prefix('admin')->namespace('Admin')->group(function () {
    Route::namespace('Auth')->middleware('guest:admin')->group(function () {
        // Login
        Route::get('/', 'LoginController@showLoginForm')->name('login');
        Route::post('/', 'LoginController@login');

        // Forget and reset Password
        Route::get('forgot-password', 'ForgotPasswordController@showLinkRequestForm')->name('forgot_password');
        Route::post('forgot-password', 'ForgotPasswordController@sendResetLinkEmail');
        Route::get('password/reset/{token}/{email?}', 'ResetPasswordController@showResetForm')->name('reset_password_link');
        Route::post('password/reset', 'ResetPasswordController@reset')->name('reset_password');
    });

    // Logged in admin user required
    Route::group(['middleware' => 'auth:admin'], function () {
        // Dashboard
        Route::get('/dashboard', 'AdminController@dashboard')->name('dashboard');

        Route::resource('semesters', 'SemesterController');

        Route::resource('subjects', 'SubjectController');

        Route::resource('students', 'StudentController');

        Route::resource('exams', 'ExamController');

        Route::resource('ads', 'AdController');

        Route::resource('teachers', 'TeacherController');

        Route::resource('results', 'ResultController');

        Route::resource('departments', 'DepartmentController');

        Route::resource('libraries', 'LibraryController');

        Route::resource('books', 'BookController');

        // Profile
        Route::get('/profile', 'AdminController@profile')->name('profile');
        Route::post('/profile', 'AdminController@profileUpdate');
        Route::post('/password', 'AdminController@passwordUpdate')->name('password_update');

        // Logout
        Route::get('/logout', 'Auth\LoginController@logout')->name('logout');
    });
});

app/Book.php
<?php

namespace App;

use Spatie\MediaLibrary\HasMedia\HasMediaTrait;
use Spatie\MediaLibrary\HasMedia\HasMedia;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Book extends Model implements HasMedia
{
    use SoftDeletes, HasMediaTrait;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'description', 'file', 'library_id'
    ];

    /**
     * Validation rules
     *
     * @return array
     **/
    public static function validationRules()
    {
        return [
            'name' => 'required|string',
            'description' => 'required|string',
            'file' => 'required|file',
            'library_id' => 'required|numeric|exists:libraries,id',
        ];
    }

    /**
     * Spatie media library collections
     *
     * @return void
     */
    public function registerMediaCollections()
    {
        $this->addMediaCollection('file')->singleFile();
    }

    /**
     * Get the library for the Book.
     */
    public function library()
    {
        return $this->belongsTo('App\Library');
    }

    /**
     * Returns the paginated list of resources
     *
     * @return \Illuminate\Pagination\Paginator
     **/
    public static function getList()
    {
        return static::with(['library', 'media'])->paginate(10);
    }
}

app/Http/Controllers/Admin/BookController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Book;
use App\Library;
use App\Http\Controllers\Controller;

class BookController extends Controller
{
    /**
     * Display a list of Books.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $books = Book::getList();

        return view('admin.books.index', compact('books'));
    }

    /**
     * Show the form for creating a new Book
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $libraries = Library::all();

        return view('admin.books.add', compact('libraries'));
    }

    /**
     * Save new Book
     *
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store()
    {
        $validatedData = request()->validate(Book::validationRules());

        unset($validatedData['file']);
        $book = Book::create($validatedData);

        $book->addMediaFromRequest('file')->toMediaCollection('file');

        return redirect()->route('admin.books.index')->with([
            'type' => 'success',
            'message' => 'Book added'
        ]);
    }

    /**
     * Show the form for editing the specified Book
     *
     * @param \App\Book $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        $libraries = Library::all();

        return view('admin.books.edit', compact('book', 'libraries'));
    }

    /**
     * Update the Book
     *
     * @param \App\Book $book
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Book $book)
    {
        $validatedData = request()->validate(
            Book::validationRules($book->id)
        );

        unset($validatedData['file']);
        $book->update($validatedData);

        $book->addMediaFromRequest('file')->toMediaCollection('file');

        return redirect()->route('admin.books.index')->with([
            'type' => 'success',
            'message' => 'Book Updated'
        ]);
    }

    /**
     * Delete the Book
     *
     * @param \App\Book $book
     * @return void
     */
    public function destroy(Book $book)
    {
        $book->delete();

        return redirect()->route('admin.books.index')->with([
            'type' => 'success',
            'message' => 'Book deleted successfully'
        ]);
    }
}

resources/views/admin/books/add.blade.php
@extends('admin.layouts.app', ['page' => 'book'])

@section('title', 'Add New Book')

@section('content')
<div class="card-header">
    <div class="row">
        <div class="col-6 pt-2 h5">
            <i class="fa fa-tint"></i>
            Add New Book
        </div>
    </div>
</div>

<div class="card-body m-2">
    <form role="form" method="POST" enctype="multipart/form-data" action="{{ route('admin.books.store') }}">
        @csrf

        <div class="form-group">
            <label for="name">Name</label>
            <input type="text"
                class="form-control"
                name="name"
                required
                placeholder="Name"
                value="{{ old('name') }}"
                id="name"
            >
        </div>

        <div class="form-group">
            <label for="description">Description</label>
            <textarea class="form-control"
                name="description"
                id="description"
                required
                placeholder="Description"
            >{{ old('description') }}</textarea>
        </div>

        <div class="form-group">
            <label for="file">File</label>
            <input type="file"
                class="form-control"
                name="file"
                required
                value="{{ old('file') }}"
                id="file"
            >
        </div>

        <div class="form-group">
            <label for="library-id">Library</label>
            <select class="form-control"
                name="library_id"
                required
                id="library-id"
            >
                @foreach ($libraries as $library)
                    <option value="{{ $library->id }}"
                        {{ old('library_id') == $library->id ? 'selected' : '' }}
                    >
                        {{ $library->name }}
                    </option>
                @endforeach
            </select>
        </div>

        <div class="card-footer">
            <button type="submit" class="btn btn-sm btn-primary">
                Submit
            </button>

            <a class="btn btn-sm btn-danger"
                href="{{ route('admin.books.index') }}"
            >
                Cancel
            </a>
        </div>
    </form>
</div>
@endsection

resources/views/admin/books/edit.blade.php
@extends('admin.layouts.app', ['page' => 'book'])

@section('title', 'Edit Book')

@section('content')
<div class="card-header">
    <div class="row">
        <div class="col-6 pt-2 h5">
            <i class="fa fa-tint"></i>
            Edit Book
        </div>
    </div>
</div>

<div class="card-body m-2">
    <form role="form" method="POST" enctype="multipart/form-data" action="{{ route('admin.books.update', ['book' => $book->id]) }}">
        @csrf
        @method('PUT')

        <div class="form-group">
            <label for="name">Name</label>
            <input type="text"
                class="form-control"
                name="name"
                required
                placeholder="Name"
                value="{{ old('name', $book->name) }}"
                id="name"
            >
        </div>

        <div class="form-group">
            <label for="description">Description</label>
            <textarea class="form-control"
                name="description"
                id="description"
                required
                placeholder="Description"
            >{{ old('description', $book->description) }}</textarea>
        </div>

        <a href="{{ $book->getFirstMediaUrl('file') }}"
            target="_blank"
        >
            &#10159; Download Current File
        </a>
        <div class="form-group">
            <label for="file">File</label>
            <input type="file"
                class="form-control"
                name="file"
                required
                value="{{ old('file', $book->file) }}"
                id="file"
            >
        </div>

        <div class="form-group">
            <label for="library-id">Library</label>
            <select class="form-control"
                name="library_id"
                required
                id="library-id"
            >
                @foreach ($libraries as $library)
                    <option value="{{ $library->id }}"
                        {{ old('library_id', $book->library_id) == $library->id ? 'selected' : '' }}
                    >
                        {{ $library->name }}
                    </option>
                @endforeach
            </select>
        </div>

        <div class="card-footer">
            <button type="submit" class="btn btn-sm btn-primary">
                Update
            </button>

            <a class="btn btn-sm btn-danger"
                href="{{ route('admin.books.index') }}"
            >
                Cancel
            </a>
        </div>
    </form>
</div>
@endsection

resources/views/admin/books/index.blade.php
@extends('admin.layouts.app', ['page' => 'book'])

@section('title', 'Books')

@section('content')
<div class="card-header">
    <div class="row">
        <div class="col-6 pt-2 h5">
            <i class="fa fa-tint"></i>
            Books
        </div>

        <div class="col-6 text-right">
            <a class="btn btn-md btn-square btn-secondary"
                href="{{ route('admin.books.create') }}"
            >
                Add New
            </a>
        </div>
    </div>
</div>

<div class="card-body m-2">
    <table class="table table-responsive-sm">
        <thead>
            <tr>
                <th>#</th>
                <th>Name</th>
                <th>Library</th>
                <th>Action</th>
            </tr>
        </thead>

        <tbody>
            @forelse ($books as $book)
                <tr>
                    <td>{{ $book->id }}</td>
                    <td>{{ $book->name }}</td>
                    <td>{{ $book->library->name }}</td>
                    <td>
                        <a class="btn btn-pill btn-sm btn-warning"
                            href="{{ route('admin.books.edit', ['book' => $book->id]) }}"
                        >
                            <i class="fa fa-pencil-square-o"></i>
                        </a>

                        <form action="{{ route('admin.books.destroy', ['book' => $book->id]) }}"
                            method="POST"
                            class="inline pointer"
                        >
                            @csrf
                            @method('DELETE')

                            <a class="btn btn-pill btn-sm btn-danger"
                                onclick="if (confirm('Are you sure?')) { this.parentNode.submit() }"
                            >
                                <i class="fa fa-trash-o"></i>
                            </a>
                        </form>
                    </td>
                </tr>
            @empty
                <tr>
                    <td colspan="4">No records found</td>
                </tr>
            @endforelse
        </tbody>
    </table>

    {{ $books->links() }}
</div>
@endsection